unit ecr_plus;
(**************************************************************************
 UNITE PERMETTANT DE METTRE DE LA COULEUR FACILEMENT DANS VOS APPLICATIONS
***************************************************************************)

interface

uses crt;{ unit seravnt  manipuler l'affichage en Pascal }

type
   (* Cette structure permet de mieux grer les menus des applications.
    *  Chaque case du tableau regroupe en effet l'intitul du choix.
    *)
   tabmenu = record
		titre : string[50];
		nb    : integer;
		choix : array [1..20] of string[70];
	     end;     
   
 procedure ini_coul( TextCoul, BackCoul : integer );
 procedure initialiser;
 procedure restaurer;
 procedure ecrire_tit( texte : string );
 procedure ecrire_men( texte : string );
 procedure ecrire_err( texte : string );
 procedure ecrire_msg( texte : string );
 procedure finir_ligne;
 procedure ecrire_perso(texte : string ; ClText,ClBack : integer );
 function gere_menu( tab : tabmenu ) : integer;
 function int2str( nb :  longint) : string;
 function str2int( s :  string ) : longint;
 function isnum(s : string) : boolean;
 procedure tronquer( var chaine : string ) ;
 function saisir_nombre : string;
 function controler_saisie(min : longint;max : longint) : string;
 
 const
{ Couleurs par dfaut pour le texte Standard }
     ClTextStd = White ;
     ClBackStd = Cyan ;
{ Couleurs par dfaut pour le texte de Titre }
     ClTextTit = Red;
     ClBackTit = ClBackStd ;
{ Couleurs par dfaut pour le texte de Menu }
     ClTextMen = Yellow ;
     ClBackMen = ClBackStd ;
{ Couleurs par dfaut pour le texte d' Erreur }
     ClTextErr = Yellow;
     ClBackErr = Red;
{ Couleurs par dfaut pour le texte de Message }
     ClTextMsg = Yellow ;
     ClBackMsg = Blue ;


 
implementation
 
{ Procedure initialisant l'cran avec les Valeurs Passes en Paramtres }
Procedure ini_coul( TextCoul, BackCoul : integer );
begin
   TextColor(TextCoul);
   TextBackground(BackCoul);
end; { ini_coul }


{ initialise l'cran avec les couleurs dfinies en constantes comme "standard" }
procedure initialiser;
begin
   ini_coul(ClTextStd,ClBackStd);
   clrscr;
end; { initialiser }


{ Sous Linux, permet d'avoir les couleurs dfinies par dfaut par le systme }
procedure restaurer;
begin
   TextColor(White);
   TextBackground(Black);
   clrscr;
end; { restaurer }


{ crit le texte pass en paramtre avec les couleurs standards pour les titres}
procedure ecrire_tit( texte : string );
begin
   ini_coul(ClTextTit,ClBackTit);
   ClrEol;
   write(texte);
   ini_coul(ClTextStd,ClBackStd);
   writeln;
end; { ecrire_tit }


{ crit le texte pass en paramtre avec les couleurs standards pour les menus}
procedure ecrire_men( texte : string );
begin
   ini_coul(ClTextMen,ClBackMen);
   ClrEol;
   write(texte);
   ini_coul(ClTextStd,ClBackStd);
   writeln;
end; { ecrire_men }


{ crit le texte pass en paramtre avec les couleurs standards pour les messages d'erreur }
procedure ecrire_err( texte : string );
begin
   ini_coul(ClTextErr,ClBackErr);
   ClrEol;
   write(texte);
   finir_ligne;
   ini_coul(ClTextStd,ClBackStd);
end; { ecrire_err }


{ crit le texte pass en paramtre avec les couleurs standards pour les messages d'avertissement }
procedure ecrire_msg( texte : string );
begin
   ini_coul(ClTextMsg,ClBackMsg);
   ClrEol;
   write(texte);
   finir_ligne;
   ini_coul(ClTextStd,ClBackStd);
end; { ecrire_msg }


(* Permet la saisie d'un entier positif. Le nombre doit obligatoirement tre renseign. *)
procedure finir_ligne;
var
   latouche : char;
begin
	latouche := readkey;
	while ord(latouche) <> 13 do
	begin
	  ClrEol;
          latouche := readkey;
	end;
	writeln;
end;


{ crit le texte pass en paramtre avec des couleurs personnelles passes en paramtre }
procedure ecrire_perso( texte : string ; ClText,ClBack : integer );
begin
   ini_coul(ClText,ClBack);
   write(texte);
   ini_coul(ClTextStd,ClBackStd);
end; { ecrire_perso }


{ controle de l'indice de selection }
procedure controleindice(var i : integer; var tab:tabmenu);
begin
   if i < 1 then
      i := tab.nb;
   if i > tab.nb then
      i := 1;
end; { controleindice }


{ permet d'crire le choix avec les couleurs "inverses" }
procedure surlignage(i,y : integer; var tab:tabmenu );
begin
   GotoXY(1,y-1-(tab.nb-i));
   ClrEol;
   ecrire_perso( '  '+ int2str(i) + ') ' + tab.choix[i] , ClBackMen, ClTextMen);   
end; { surlignage }


{ permet de rcrire le choix avec les couleurs "normales" }
procedure desurlignage(i,y : integer; var tab:tabmenu );
begin
   GotoXY(1,y-1-(tab.nb-i));
   ClrEol;
   ecrire_men( '  '+int2str(i) + ') ' + tab.choix[i] );
end; { desurlignage }


(*
 * Cette fonction permet d'afficher un menu, c'est  dire un choix d'options.
 *  Elle permet aussi d'utiliser les touches '-' et '+' pour slectionner
 *  les options  dsires.
 *  *)
function gere_menu( tab : tabmenu ) : integer;
var
   i,iaux,auxi : integer;
   touche      : string;
   x,y	       : integer;
   continue    : boolean;
	    
begin
   (* criture du menu avec le contenu du tableau pass en paramtre *)
   clrscr;
   writeln;
   ecrire_tit(' *** ' + tab.titre +' ***');
   for  i:=1 to tab.nb do
      ecrire_men( '  ' + int2str(i) + ') ' + tab.choix[i] );
   write(' Votre choix : ');
   ClrEol;
  (* sauvegarde des coordonnes de la fin du menu *)
   y := WhereY;
   x := WhereX;
   
   i := 0;
   continue := true;
   touche := readKey;
   
   while continue do 
   begin
      (* controle de la touche frappe *)
      if not isnum(touche) then{ touche non numrique }
      begin
	 if (touche = '-' ) or (touche = '+' )then
	 begin
	    controleindice(i,tab);
	    (* Rcriture du choix sous forme "normale" *)
	    desurlignage(i,y,tab);
	    (* dplacement de l'indice de slection selon la touche saisie *)
	    if touche = '-'  then
	       i := i - 1
	    else
	       i := i+1;
	    controleindice(i,tab);
	    (* surlignage du choix slectionn *)
	    surlignage(i,y,tab);
	    (* criture du numro du choix ralis *)
	    GotoXY(x,y);
	    ClrEol;
	    write(i);
	 end;
	 if ( touche = #13 ) and  (i<=tab.nb) and  (i>=1) then
	    continue:=false
	 else
	    touche := readKey;
      end
      else{ la touche est "numrique" }
      begin
	 iaux := 0;
	 while (touche<>#13) and ( isnum(touche) )do
	 begin
	    auxi:=str2int(touche);
	    iaux := iaux * 10 + auxi; 
	    if (iaux > tab.nb) or ( iaux < 1 )then{ L'utilisateur a choisi un nombre hors plage }
	    begin
	       if (auxi <= tab.nb ) and ( auxi >= 1 )then
	       begin
		  if i>0 then { l'indice du choix prcdent doit tre dans la plage pour le dslectionner}
		     desurlignage(i,y,tab);
		  surlignage(auxi,y,tab);
		  iaux:=auxi;
		  i:=iaux;
		  GotoXY(x,y);
		  ClrEol;
		  write(i);
	       end;
	    end
	    else{ l'utilisateur   choisi un nombre dans la plage de slection }
	    begin
	       if ( i > 0 ) and ( i<= tab.nb) then{ l'indice du choix prcdent doit tre dans la plage pour le dslectionner}
		  desurlignage(i,y,tab);
	       { surlignage de l'indice choisi }
	       surlignage(iaux,y,tab);
	       i:=iaux;
	       GotoXY(x,y);
	       ClrEol;
	       write(i);
	    end;
	    touche := readkey;
	 end;
	 if touche = #13 then
	    continue := false;
      end;
   end;
   writeln;
   writeln;
   gere_menu := i;
end; { gere_menu }


{ retourne sous forme de chaine l'entier nb }
function int2str( nb :  longint) : string;
var chaine : string;
begin
   str(nb,chaine);
   int2str := chaine;
end; { int2str }


{ retourne sous forme d'entier, la chaine s }
function str2int( s :  string ) : longint;
var nb : longint;
   err : word;
begin
   val(s,nb,err);
   if(err<>0) then
      str2int:=0
   else
      str2int := nb;
end; { str2int }


{ retourne vrai si la chaine passe en paramtre reprsente un entier }
function isnum(s : string) : boolean;
var nb	: longint;
   code	: word;
begin
   Val ( s , nb , code ) ;
   isnum := ( Code = 0 );
end; { isnum }



(* Supprime le dernier caractre de la chane reprsentant un nombre *)
procedure tronquer( var chaine : string ) ;
var
   sous_chaine : string ;
   i           : longint;
   lg          : longint;
begin

  i := 1;
  sous_chaine := chaine[i];

  lg := length(chaine) - 1;
  i := i +1 ;

  while i <= lg do
  begin
	sous_chaine := sous_chaine + chaine[i];
	i:=i+1;
  end;

  chaine := sous_chaine;
end;



(* Permet la saisie d'un entier positif. Le nombre doit obligatoirement tre renseign. *)
function saisir_nombre : string;
var
   latouche : char;
   lenombre : string;
   x        : integer;
   y        : integer;
begin

   lenombre := ' ';
   latouche := ' ';
   x := WhereX;
   y := WhereY;

   while not isnum(lenombre) do 
   begin
	lenombre := ' ';
        latouche := ' ';

	   while ord(latouche) <> 13 do { <> entre }
	   begin

	        latouche := readkey;

		while isnum(latouche) do
		begin
		     write(latouche);
		     lenombre := lenombre + latouche;
		     latouche := readkey;
		end;

		if ( ord(latouche) = 8 ) then { touche "<=" }
		begin
			GotoXY(WhereX-1,WhereY);
			ClrEol;
			tronquer(lenombre);
		end;
	   end;

	if isnum(lenombre) then		
		lenombre := int2str(str2int(lenombre));
	GotoXY(x,y);	
   end;

   writeln;

   saisir_nombre := lenombre;
end;


(* Permet de saisir un nombre compris entre nmin et max inclus *)
function controler_saisie(min : longint; max : longint) : string;
var lenombre : string;
    ok       : boolean;
begin
   ok := false;
   while ok = false do
   begin
	   lenombre := saisir_nombre;
	   if isnum(lenombre) then
	   begin
		if ( str2int(lenombre) < min ) or ( str2int(lenombre) > max ) then
		begin
		     ecrire_err('Le nombre doit tre compris entre '+ int2str(min) + ' et ' + int2str(max));
		end
		else ok := true;
	   end;
   end;	
   controler_saisie := lenombre;
end;




end.
